#!/usr/bin/env node
var x = Object.defineProperty;
var F = (e, t, s) => t in e ? x(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var h = (e, t, s) => (F(e, typeof t != "symbol" ? t + "" : t, s), s);
import { B as c, e as y, a as l, F as d } from "./app-automate-M2JoH-jG.js";
import { randomBytes as b } from "node:crypto";
import { readFile as E } from "node:fs/promises";
import { createRequire as k } from "node:module";
import { resolve as L, basename as T } from "node:path";
function S(e) {
  const t = e ?? y.BROWSERSTACK_KEY;
  if (typeof t != "string" || !t.trim().length)
    throw new c("Missing key");
  return t.trim();
}
function $(e) {
  const t = e ?? y.BROWSERSTACK_USERNAME;
  if (typeof t != "string" || !t.trim().length)
    throw new c("Missing key");
  return t.trim();
}
const U = k(import.meta.url);
var A = /* @__PURE__ */ ((e) => (e.upload = "upload", e.get = "get", e.list = "list", e.delete = "delete", e))(A || {});
class m {
  constructor(t, s, n) {
    h(this, "appPlatform");
    h(this, "supportedActions");
    h(this, "_implPlatformCommand");
    this.appPlatform = t, this.supportedActions = s, this._implPlatformCommand = n;
  }
  async list(t, s, n) {
    (await this._implPlatformCommand.list(t, s)).forEach((a) => this._logApp(a, n));
  }
  async upload(t, s, n) {
    const { filename: o, filePath: a, url: r, ...p } = t, i = await this._implPlatformCommand.upload(
      {
        filename: o,
        ...a ? { file: new Blob([await E(a)]) } : { url: r.toString() }
      },
      p,
      s
    );
    i != null && i.app_url ? n.info(i.app_url, "Uploaded successfully") : n.error("Failed to upload app", i);
  }
  async get(t, s, n) {
    const { appId: o, ...a } = t, r = await this._implPlatformCommand.get(
      { appId: m.cleanAppId(o) },
      a,
      s
    );
    this._logApp(r, n);
  }
  async delete(t, s, n) {
    const { appId: o, ...a } = t;
    await this._implPlatformCommand.delete(
      { appId: m.cleanAppId(o) },
      a,
      s
    ) ? n.info(`bs://${o}`, "Deleted successfully") : n.error(`Failed to delete app: ${o}`);
  }
  _logApp(t, s) {
    s.info(
      t.app_url,
      t.uploaded_at ? new Date(t.uploaded_at).toISOString() : "",
      t.app_name,
      t.app_version
    );
  }
  static cleanAppId(t, s = "bs://") {
    return t.startsWith(s) ? t.replace(s, "") : t;
  }
}
const _ = (e) => {
  const { test_package_id: t, test_package_url: s, test_package_name: n, ...o } = e;
  return {
    ...o,
    app_id: t,
    app_url: s,
    app_name: n
  };
}, I = (e, t = Object.values(d)) => {
  if (!e || !t.includes(e))
    throw new c(
      `Invalid or missing flutter platform. Supported platforms: ${t.sort().join(", ")}`
    );
  return e;
}, P = new m(
  "flutter",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    list: (e, t) => {
      var o, a, r, p;
      const s = new l(e);
      return I(
        (p = (r = (a = (o = t[0]) == null ? void 0 : o.toLowerCase) == null ? void 0 : a.call(o)) == null ? void 0 : r.trim) == null ? void 0 : p.call(r)
      ) === d.android ? s.getFlutterApps(d.android) : s.getFlutterApps(d.ios).then((i) => i.map(_));
    },
    upload: (e, t, s) => {
      var a, r, p, i, u, f, w, g;
      const n = new l(t);
      let o = (i = (p = (r = (a = s[0]) == null ? void 0 : a.toLowerCase) == null ? void 0 : r.call(a)) == null ? void 0 : p.trim) == null ? void 0 : i.call(p);
      return !o && ((g = (w = (f = (u = e.filename) == null ? void 0 : u.toLowerCase) == null ? void 0 : f.call(u)) == null ? void 0 : w.match) != null && g.call(w, /\.(apk|aar|appbundle)$/)) ? o = d.android : o = I(o), o === d.android ? n.uploadFlutterApp(d.android, e) : n.uploadFlutterApp(d.ios, e).then(_);
    },
    get: (e, t, s) => {
      var a, r, p, i;
      const n = new l(t);
      return I(
        (i = (p = (r = (a = s[0]) == null ? void 0 : a.toLowerCase) == null ? void 0 : r.call(a)) == null ? void 0 : p.trim) == null ? void 0 : i.call(p)
      ) === d.android ? n.getFlutterApp(d.android, e.appId) : n.getFlutterApp(d.ios, e.appId).then(_);
    },
    delete: async (e, t, s) => {
      var r, p, i, u, f, w;
      const n = new l(t), a = await (I(
        (u = (i = (p = (r = s[0]) == null ? void 0 : r.toLowerCase) == null ? void 0 : p.call(r)) == null ? void 0 : i.trim) == null ? void 0 : u.call(i)
      ) === d.android ? n.deleteFlutterApp(d.android, e.appId) : n.deleteFlutterApp(d.ios, e.appId));
      return ((w = (f = a == null ? void 0 : a.success) == null ? void 0 : f.message) == null ? void 0 : w.length) > 0;
    }
  }
), C = (e) => {
  if (!e.custom_id)
    return e;
  const t = e.app_id;
  return {
    ...e,
    app_id: e.custom_id,
    app_url: `bs://${e.custom_id}`,
    custom_id: t
  };
}, B = new m(
  "appium",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    list: (e) => new l(e).getAppiumApps().then((s) => s.map(C)),
    upload: (e, t) => new l(t).uploadAppiumApp({
      ...e,
      custom_id: b(20).toString("hex")
    }).then(C),
    get: (e, t) => new l(t).getAppiumAppsByCustomId(e.appId).then((n) => {
      if (!n.length)
        throw new c(
          `No app found with custom ID: ${e.appId}`
        );
      return C(n[0]);
    }),
    delete: async (e, t) => {
      const s = new l(t), [n] = await s.getAppiumAppsByCustomId(e.appId), o = (n == null ? void 0 : n.app_id) ?? e.appId, a = await s.deleteAppiumApp(o);
      return (a == null ? void 0 : a.success) === !0;
    }
  }
), O = new m(
  "espresso",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    list: (e) => new l(e).getEspressoApps(),
    upload: (e, t) => new l(t).uploadEspressoApp(e),
    get: (e, t) => new l(t).getEspressoApp(e.appId),
    delete: async (e, t) => {
      var o, a;
      const n = await new l(t).deleteEspressoApp(e.appId);
      return ((a = (o = n == null ? void 0 : n.success) == null ? void 0 : o.message) == null ? void 0 : a.length) > 0;
    }
  }
), D = new m(
  "xcuitest",
  [
    "upload",
    "list",
    "get",
    "delete"
    /* delete */
  ],
  {
    list: (e) => new l(e).getXCUITestApps(),
    upload: (e, t) => new l(t).uploadXCUITestApp(e),
    get: (e, t) => new l(t).getXCUITestApp(e.appId),
    delete: async (e, t) => {
      var o, a;
      const n = await new l(t).deleteXCUITestApp(e.appId);
      return ((a = (o = n == null ? void 0 : n.success) == null ? void 0 : o.message) == null ? void 0 : a.length) > 0;
    }
  }
), W = new m(
  "detox",
  [
    "upload"
    /* upload */
  ],
  {
    upload: (e, t, s) => {
      var o, a, r, p;
      const n = (p = (r = (a = (o = s == null ? void 0 : s[0]) == null ? void 0 : o.toLowerCase) == null ? void 0 : a.call(o)) == null ? void 0 : r.trim) == null ? void 0 : p.call(r);
      switch (n) {
        case "app":
        case "app-client":
          return new l(t).uploadDetoxAndroidApp(n, e);
        default:
          throw new c(
            "Invalid or missing detox app type. Supported types: app, app-client"
          );
      }
    },
    list: () => {
      throw new c("Listing detox apps is not supported");
    },
    get: () => {
      throw new c("Fetching detox apps is not supported");
    },
    delete: () => {
      throw new c("Deleting detox apps is not supported");
    }
  }
), v = /* @__PURE__ */ new Map([
  ["flutter", P],
  ["appium", B],
  ["espresso", O],
  ["xcuitest", D],
  ["detox", W]
]);
async function j(e, t, s, n = globalThis.console, o = ["android", "ios"]) {
  var a, r, p;
  if (!e.supportedActions.includes(t))
    throw new c(
      `Invalid action: ${t} (valid actions: ${e.supportedActions.join(
        ", "
      )})`
    );
  switch (t) {
    case "upload": {
      const i = s.shift();
      if (!i)
        throw new c("No file path or URL provided");
      if ((p = (a = i == null ? void 0 : i.toLowerCase) == null ? void 0 : (r = a.call(i)).startsWith) != null && p.call(r, "http")) {
        if (!s[0] || o.includes(s[0]))
          throw new c("No filename provided for URL upload");
        return await e.upload(
          { url: new URL(i), filename: s[0] },
          s.slice(1),
          n
        );
      }
      const u = L(i);
      await e.upload(
        {
          filePath: u,
          filename: T(u)
        },
        s,
        n
      );
      break;
    }
    case "list": {
      await e.list({}, s, n);
      break;
    }
    case "get": {
      await e.get({ appId: s[0] }, s.slice(1), n);
      break;
    }
    case "delete": {
      await e.delete({ appId: s[0] }, s.slice(1), n);
      break;
    }
    default:
      throw new c(`Unsupported action: ${t}`);
  }
}
function K(e) {
  var s, n, o;
  const t = (o = (n = (s = e == null ? void 0 : e.toLowerCase) == null ? void 0 : s.call(e)) == null ? void 0 : n.trim) == null ? void 0 : o.call(n);
  if (t && v.has(t))
    return t;
  throw new c(`Invalid app platform: ${t}`);
}
function M(e, t = Object.values(A)) {
  var n, o, a;
  const s = (a = (o = (n = e == null ? void 0 : e.toLowerCase) == null ? void 0 : n.call(e)) == null ? void 0 : o.trim) == null ? void 0 : a.call(o);
  if (s && t.includes(s))
    return s;
  throw new c(`Invalid action: ${s}`);
}
async function N(e = process.argv.slice(2), t = globalThis.console) {
  try {
    S(void 0), $(void 0);
    const s = e.map((a) => a.trim()), n = v.get(
      K(s[0])
    );
    if (!n)
      throw new c("Invalid app platform");
    const o = M(s[1]);
    await j(n, o, s.slice(2), t);
  } catch (s) {
    s instanceof Error ? t.error(s.message) : t.error(`An unexpected error occurred: ${s}`), process.exit(1);
  }
}
U.main === module && N();
export {
  N as main
};
